HDU 1072-Nightmare

Nightmare

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 12418    Accepted Submission(s): 6067


题目链接:点击打开链接


Problem Description
Ignatius had a nightmare last night. He found himself in a labyrinth with a time bomb on him. The labyrinth has an exit, Ignatius should get out of the labyrinth before the bomb explodes. The initial exploding time of the bomb is set to 6 minutes. To prevent the bomb from exploding by shake, Ignatius had to move slowly, that is to move from one area to the nearest area(that is, if Ignatius stands on (x,y) now, he could only on (x+1,y), (x-1,y), (x,y+1), or (x,y-1) in the next minute) takes him 1 minute. Some area in the labyrinth contains a Bomb-Reset-Equipment. They could reset the exploding time to 6 minutes.

Given the layout of the labyrinth and Ignatius' start position, please tell Ignatius whether he could get out of the labyrinth, if he could, output the minimum time that he has to use to find the exit of the labyrinth, else output -1.

Here are some rules:
1. We can assume the labyrinth is a 2 array.
2. Each minute, Ignatius could only get to one of the nearest area, and he should not walk out of the border, of course he could not walk on a wall, too.
3. If Ignatius get to the exit when the exploding time turns to 0, he can't get out of the labyrinth.
4. If Ignatius get to the area which contains Bomb-Rest-Equipment when the exploding time turns to 0, he can't use the equipment to reset the bomb.
5. A Bomb-Reset-Equipment can be used as many times as you wish, if it is needed, Ignatius can get to any areas in the labyrinth as many times as you wish.
6. The time to reset the exploding time can be ignore, in other words, if Ignatius get to an area which contain Bomb-Rest-Equipment, and the exploding time is larger than 0, the exploding time would be reset to 6.
 

Input
The input contains several test cases. The first line of the input is a single integer T which is the number of test cases. T test cases follow.
Each test case starts with two integers N and M(1<=N,Mm=8) which indicate the size of the labyrinth. Then N lines follow, each line contains M integers. The array indicates the layout of the labyrinth.
There are five integers which indicate the different type of area in the labyrinth:
0: The area is a wall, Ignatius should not walk on it.
1: The area contains nothing, Ignatius can walk on it.
2: Ignatius' start position, Ignatius starts his escape from this position.
3: The exit of the labyrinth, Ignatius' target position.
4: The area contains a Bomb-Reset-Equipment, Ignatius can delay the exploding time by walking to these areas.
 

Output
For each test case, if Ignatius can get out of the labyrinth, you should output the minimum time he needs, else you should just output -1.

Sample Input
3
3 3
2 1 1
1 1 0
1 1 3
4 8
2 1 1 0 1 1 1 0
1 0 4 1 1 0 4 1
1 0 0 0 0 0 0 1
1 1 1 4 1 1 1 3
5 8
1 2 1 1 1 1 1 4 
1 0 0 0 1 0 0 1 
1 4 1 0 1 1 0 1 
1 0 0 0 0 3 0 1 
1 1 4 1 1 1 1 1 
 


Sample Output
4
-1
13



题意:
有一个人做了一个噩梦,梦见自己在一个迷宫里,并且迷宫里有一个定时炸弹,初始时间设置为6分钟,现在他可以朝前后左右四个方向移动,每移动一次就 消耗 1 分钟,然后现在将这个迷宫虚拟成一个矩阵
0 代表墙,人不能走的位置
1 代表空地,人可以移动的位置
2 人的起始位置
3 迷宫的出口
4 炸弹重置器所在的位置,在该位置可以重置炸弹的时间,将炸弹的时间调至初始的 6 分钟
但条件是:不能走出迷宫的边界;如果走到出口的时间正好为 0 ,则代表走不出迷宫;同样的,如果走到炸弹重置器的位置正好为 0,也不能使用炸弹重置器。
问他能否走出迷宫,如果可以走出迷宫,输出用的最少的时间,如果走不出迷宫就输出 -1


分析:
本题是BFS+队列,具体见代码。
在BFS中罗列情况的时候将出口的情况最后罗列出来,因为前面的情况中都会考虑到时间的问题,所以当最后如果还能进行到判断出口的情况,那么一定可以走出迷宫,不需要考虑其他。





#include<iostream>
#include<stdio.h>
#include<queue>
#include<string>
#include<cstring>
using namespace std;
int n,m;///矩阵的行数与列数
int s[10][10];///存迷宫地图
int bj[10][10];///存该点所剩的最大的时间
int dir[4][2]={{0,1},{-1,0},{0,-1},{1,0}};///方向

struct book{///结构体保存该位置的步数与所剩时间
    int x,y,step,time;
};

int bfs(int a,int b)
{
   memset(bj,0,sizeof(bj));///初始化将bj数组刷为0
   queue <book> q;///定义个结构体队列
   book h,next;///h记录当前情况,next记录走下一步的情况
   h.x=a;
   h.y=b;
   h.step=0;
   h.time=6;
   bj[a][b]=6;///起始位置炸弹时间为6
   q.push(h);
   while(!q.empty())
   {
       h=q.front();
       q.pop();
       for(int i=0;i<4;i++)
       {
           next.x=h.x+dir[i][0];
           next.y=h.y+dir[i][1];
           next.step=h.step+1;
           next.time=h.time-1;
           if(next.x>=0&&next.x<n&&next.y>=0&&next.y<m)///保证不出界的情况下
           {
               if(s[next.x][next.y]==0)///如果该点为墙则再走其他方向
                    continue;
               if(s[next.x][next.y]==1)///如果该点为空地
               {
                   if(next.time==1)///时间如果剩 1,则下一步走哪都死
                        continue;
                   if(bj[next.x][next.y]<next.time)///如果该次在该点所剩时间比上次在该点所剩时间多,就更新
                   {
                       bj[next.x][next.y]=next.time;
                       q.push(next);
                   }
               }
               else if(s[next.x][next.y]==4)///如果该点可以重置炸弹
               {
                   if(6>bj[next.x][next.y])///注意这里是和bj数组里所剩时间比较,而不是next.time
                   {
                       next.time=6;
                       bj[next.x][next.y]=6;
                       q.push(next);
                   }
               }
               else if(s[next.x][next.y]==3)///当遇见出口就返回所用的步数
                    return next.step;
           }
       }
   }
    return -1;
}

int main()
{
    int t,xx,yy;
    scanf("%d",&t);
    while(t--)
    {
        scanf("%d %d",&n,&m);
        for(int i=0;i<n;i++)
        {
            for(int j=0;j<m;j++)
            {
                scanf("%d",&s[i][j]);
                if(s[i][j]==2)
                {
                   xx=i;
                   yy=j;
                }
            }
        }
        printf("%d\n",bfs(xx,yy));
    }
    return 0;
}







 
  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值